import java.util.*;

/**
 * 事務室を表すクラス（Office）
 */
public class Office {

   /**
    * 学生名・得点を保持する
    */
	private ArrayList<Score> scoreList;  // ScoreクラスのArrayList

	/**
	 * 事務室名を保持する
	 */
	private String name;

   /**
    * コンストラクタ
    * @param name 事務室の名前
    */
	public Office(String name) {
      this.name = name;
		this.scoreList = new ArrayList<Score>();
	}

	/**
	 * 得点を登録する
	 * @param studentName 学生の名前
	 * @param scoreValue 点数
	 */
	public void registerScore(String studentName, int scoreValue) {
      Score score = new Score(studentName, scoreValue);
		scoreList.add(score);
	}

	/**
	 * 全ての得点を表示する
	 */
	public void showAllScores() {
      System.out.printf("%sに登録されている全得点\n", this.name );
		for (Score score : scoreList) {
			System.out.printf("学生名:%s,", score.getStudentName());
			System.out.printf("得点:%d\n", score.getScoreValue());
		}
	}

	/**
	 * 平均点を表示する
	 */
	public void showAverageScore() {
		int sum = 0;
		for (Score score : scoreList) {
			sum += score.getScoreValue();
		}
		System.out.printf("%sに登録されている得点の平均:%.2f\n", this.name, (double) sum / scoreList.size());
	}

	/**
	 * 最高点を求めて表示する
	 */
	public void showMaxScore() {
		// ArrayListの最初の要素を仮の最高平均得点としておく
		int currentScore = scoreList.get(0).getScoreValue();
		String currentName = scoreList.get(0).getStudentName();

		// 拡張for文を用いて、最高平均得点の学生を検索
		for (Score score : scoreList) {
			if (currentScore < score.getScoreValue()) {
				currentScore = score.getScoreValue();
				currentName = score.getStudentName();
			}
		}
		System.out.printf("%sに登録されている最高得点は学生名:%s, 得点:%d\n", this.name, currentName, currentScore);
	}
}
